
#ifndef ASTVISITOR_H
#define ASTVISITOR_H

class FctDef;
class Block;
class Parameter;
class IfStatement;
class IfElseStatement;
class WhileStatement;
class Literal;
class Identifier;
class NaryExpression;
class Assignment;
class VarDecl;

class AstVisitor {

 protected:

  AstVisitor() { };

 public:

  virtual ~AstVisitor() { }

  virtual void visit(FctDef& x) = 0;
  virtual void visit(Block& x) = 0;
  virtual void visit(Parameter& x) = 0;
  virtual void visit(IfStatement& x) = 0;
  virtual void visit(IfElseStatement& x) = 0;
  virtual void visit(WhileStatement& x) = 0;
  virtual void visit(Literal& x) = 0;
  virtual void visit(Identifier& x) = 0;
  virtual void visit(NaryExpression& x) = 0;
  virtual void visit(Assignment& x) = 0;
  virtual void visit(VarDecl& x) = 0;


};






#endif
